// -------------------------------------------------------------------------------
// 
// 		cwCu		OvO
// 
// 				Ver 3.21d
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define DX_MAKE

// CN[h ------------------------------------------------------------------
#include "DxLog.h"

#ifndef DX_NON_LOG

#include "DxLib.h"
#include "DxFont.h"
#include "DxStatic.h"
#include "DxBaseFunc.h"
#include "DxUseCLib.h"
#include "DxSystem.h"
#include "DxMemory.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

LOGDATA LogData ;

// ֐vg^Cv錾-----------------------------------------------------------

#ifndef DX_NON_PRINTF_DX

// Oo͋@\֐
static	int			RefreshLogFont( void ) ;												// OŎgpĂtHgXV
static	int			CrLog( void ) ;															// s
static	int			AddCharLog( const wchar_t *C ) ;										// ꕶ邩ׂāAKvȂs
static	int			AddLog( const wchar_t *String ) ;										// Oo
static	int			ClrLog( void ) ;														// Ȍ

#endif // DX_NON_PRINTF_DX

// vO --------------------------------------------------------------------

// Ot@CpX쐬
static void CreateErrorLogFilePath( wchar_t *FilePathBuffer, size_t BufferBytes )
{
	int Len ;

	// Oo̓tH_w肳ĂȂꍇ̓JgfBNgɂ
	if( LogData.LogOutDirectory[ 0 ] == L'\0' )
	{
		DX_FGETDIR( FilePathBuffer, BufferBytes ) ; 
	}
	else
	{
		_WCSCPY_S( FilePathBuffer, BufferBytes, LogData.LogOutDirectory ) ;
	}

	Len = ( int )_WCSLEN( FilePathBuffer ) ;
	if( FilePathBuffer[ Len - 1 ] != L'\\' &&
		FilePathBuffer[ Len - 1 ] != L'/' )
	{
		_WCSCAT_S( FilePathBuffer, BufferBytes, L"\\" ) ;
		Len = ( int )_WCSLEN( FilePathBuffer ) ;
	}
	_WCSCPY_S( FilePathBuffer + Len, BufferBytes - Len * sizeof( wchar_t ), LogData.LogFileName ) ;
}

// Ot@C
extern int LogFileInitialize( void )
{
	wchar_t LogFilePath[ 1024 ] ;

	// ɏĂ牽I
	if( LogData.InitializeFlag )
	{
		return 0 ;
	}

	// Oo͗}tOĂꍇ͏o͂sȂ
	if( LogData.NotLogOutFlag == TRUE )
	{
		return 0 ;
	}

	// [U[w̃Ot@Cꍇ͂gp
	if( LogData.UserLogFileName[ 0 ] != L'\0' )
	{
		_WCSCPY_S( LogData.LogFileName, sizeof( LogData.LogFileName ), LogData.UserLogFileName ) ;
	}
	else
	// t̃Oo͂w肳Ăꍇ̓t@C쐬
	if( LogData.UseLogDateName == TRUE )
	{
		DATEDATA Date ;
		wchar_t String[128] ;

		// t擾
		NS_GetDateTime( &Date ) ;

		// ̍쐬
		_WCSCPY( LogData.LogFileName, L"Log" ) ;
		_ITOAW( Date.Year, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L"_" ) ;
		_ITOAW( Date.Mon, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L"_" ) ;
		_ITOAW( Date.Day, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L"_" ) ;
		_ITOAW( Date.Hour, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L"_" ) ;
		_ITOAW( Date.Min, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L"_" ) ;
		_ITOAW( Date.Sec, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L".txt" ) ;
	}
	else
	{
		// ȊȌꍇ͒ʏ̃t@C
		_WCSCPY( LogData.LogFileName, L"Log.txt" ) ;
	}

	// Ot@C̃pX쐬
	CreateErrorLogFilePath( LogFilePath, sizeof( LogFilePath ) ) ;

	// NeBJZNV̏
	CriticalSection_Initialize( &LogData.CriticalSection ) ;

	// ˑ
	if( LogFileInitialize_PF( LogFilePath ) < 0 )
	{
		return -1 ;
	}

	// ^u
	LogData.LogFileTabNum = 0 ; 

	// ^uo̓XgbvtO|
	LogData.LogFileTabStop = FALSE ;

	// X^[g̃^CX^v擾
	LogData.LogStartTime = NS_GetNowCount() ;

	// tO𗧂Ă
	LogData.InitializeFlag = TRUE ;

	// I
	return 0 ;
}

// Ot@C( Log.txt ) ɕo͂
extern int LogFileAdd_WCHAR_T( int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const wchar_t *String )
{
	wchar_t			LogFilePath[ FILEPATH_MAX ] ;
	wchar_t *		UseBuffer ;
	wchar_t 		DefaultBuffer[ 1024 ] ;
	wchar_t *		AllocBuffer = NULL ;
	wchar_t *		Dest ;

	// G[R[h 0 ȊOG[ݒs
	if( ErrorCode != 0 )
	{
		DxLib_SetLastError( ErrorCode, String ) ;
	}

	// Oo͗}tOĂꍇ͏o͂sȂ
	if( LogData.NotLogOutFlag == TRUE )
	{
		return ErrorCode != 0 ? -1 : 0 ;
	}

	// ĂȂ珉
	if( LogData.InitializeFlag == FALSE )
	{
		if( LogFileInitialize() < 0 )
		{
			return -1 ;
		}
	}

	// NeBJZNV̎擾
	CRITICALSECTION_LOCK( &LogData.CriticalSection ) ;

	// ^CX^v^u܂߂񂪃ftHg̃obt@e|̈Ŋmۂ
	{
		DWORD StringLength ;

		StringLength = ( DWORD )_WCSLEN( String ) ;
		if( StringLength * 2 + 16 + LogData.LogFileTabNum > sizeof( DefaultBuffer ) / sizeof( wchar_t ) - 1 )
		{
			AllocBuffer = ( wchar_t * )NS_DxAlloc( ( StringLength * 2 + 16 + LogData.LogFileTabNum ) * sizeof( wchar_t ) ) ;
			UseBuffer   = AllocBuffer ;
		}
		else
		{
			UseBuffer = DefaultBuffer ;
		}
		Dest = UseBuffer ;
	}

	// K蕪^uǉ
	if( LogData.LogFileTabStop == FALSE )
	{
		int i ;	

		// ^CX^vo
		if( LogData.NonUseTimeStampFlag == 0 )
		{
			_SWPRINTF( Dest, L"%d:", NS_GetNowCount() - LogData.LogStartTime ) ;
			Dest += _WCSLEN( Dest ) ;
		}

		if( LogData.LogFileTabNum != 0 )
		{
			for( i = 0 ; i < LogData.LogFileTabNum ; i ++, Dest ++ )
			{
				*Dest = L'\t' ;
			}
			*Dest = L'\0' ;
		}
	}

	// \n  \r\n ɕϊȂo͕Rs[
	{
		const wchar_t *	p1 ;
		const wchar_t *	p2 ;

		p1 = String ;
		p2 = _WCSCHR( p1, L'\n' ) ;
		while( p2 != NULL && ( String == p2 || p2[ -1 ] != L'\r' ) )
		{
			_MEMCPY( Dest, p1, ( p2 - p1 ) * sizeof( wchar_t ) ) ;
			Dest     += p2 - p1 ;
			Dest[ 0 ] = L'\r' ;
			Dest[ 1 ] = L'\n' ;
			Dest[ 2 ] = L'\0' ;
			Dest     += 2 ;
			p1        = p2 + 1 ;
			p2        = _WCSCHR( p1, L'\n' ) ;
		}
		_WCSCPY( Dest, p1 ) ;
	}

	// Ō̕sӊOꍇ̓^uXgbvtO𗧂Ă
	LogData.LogFileTabStop = UseBuffer[ _WCSLEN( UseBuffer ) - 1 ] != L'\n' ? TRUE : FALSE ;

	// Ot@C̃pX쐬
	CreateErrorLogFilePath( LogFilePath, sizeof( LogFilePath ) ) ;

	// ˑ
	LogFileAdd_WCHAR_T_PF( LogFilePath, UseBuffer ) ;

	// e|̈mۂĂJ
	if( AllocBuffer != NULL )
	{
		NS_DxFree( AllocBuffer ) ;
	}

	// NeBJZNV̉
	CriticalSection_Unlock( &LogData.CriticalSection ) ;
	
	// I
	return ErrorCode != 0 ? -1 : 0 ;
}















// Ot@Cɕo( char )
extern int LogFileAddA( const char *String )
{
#ifdef UNICODE
	int Result ;

	SHIFT_JIS_TO_WCHAR_T_STRING_ONE_BEGIN( String, return -1 ) ;

	Result = LogFileAdd_WCHAR_T( 0, UseStringBuffer ) ;

	SHIFT_JIS_TO_WCHAR_T_STRING_END( String ) ;

	return Result ;
#else
	int Result ;

	CHAR_TO_WCHAR_T_STRING_BEGIN( String )
	CHAR_TO_WCHAR_T_STRING_SETUP( String, return -1, DX_CHARCODEFORMAT_SHIFTJIS ) ;

	Result = LogFileAdd_WCHAR_T( 0, UseStringBuffer ) ;

	CHAR_TO_WCHAR_T_STRING_END( String ) ;

	return Result ;
#endif
}

// Ot@Cɕo( wchar_t )
extern int LogFileAddW( const wchar_t *String )
{
	return LogFileAdd_WCHAR_T( 0, String ) ;
}

// Ot@Cɕo( UTF16LE )
extern int LogFileAddUTF16LE( const char *String )
{
	int Result ;

	CHAR_TO_WCHAR_T_STRING_BEGIN( String )
	CHAR_TO_WCHAR_T_STRING_SETUP( String, return -1, DX_CHARCODEFORMAT_UTF16LE ) ;

	Result = LogFileAdd_WCHAR_T( 0, UseStringBuffer ) ;

	CHAR_TO_WCHAR_T_STRING_END( String ) ;

	return Result ;
}

// Ot@Cɏto( char )
extern int LogFileFmtAddA( const char *FormatString , ... )
{
	va_list VaList ;
	char String[ 2048 ] ;
	
	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	CL_vsnprintf( DX_CHARCODEFORMAT_SHIFTJIS, FALSE, DX_CHARCODEFORMAT_SHIFTJIS, WCHAR_T_CHARCODEFORMAT, String , sizeof( String ), FormatString , VaList ) ;
	
	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// sǉ
	_STRCAT_S( String, sizeof( String ), "\n" ) ;

	// Oo͂
	return LogFileAddA( String ) ;
}

// Ot@Cɏto( wchar_t )
extern int LogFileFmtAddW( const wchar_t *FormatString , ... )
{
	va_list VaList ;
	wchar_t String[ 2048 ] ;
	
	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	_VSWNPRINTF( String, sizeof( String ) / 2, FormatString, VaList ) ;
	
	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// sǉ
	_WCSCAT_S( String, sizeof( String ), L"\n" ) ;

	// Oo͂
	return LogFileAddW( String ) ;
}

// Ot@Cɏto( UTF16LE )
extern int LogFileFmtAddUTF16LE( const char *FormatString , ... )
{
	va_list VaList ;
	char String[ 2048 ] ;
	BYTE UTF16LE_EN_N[ 4 ] = { '\n', 0, 0, 0 } ;
	
	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	CL_vsnprintf( DX_CHARCODEFORMAT_UTF16LE, TRUE, CHAR_CHARCODEFORMAT, DX_CHARCODEFORMAT_UTF16LE, String, sizeof( String ) / 2, FormatString, VaList ) ;
	
	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// sǉ
	CL_strcat_s( DX_CHARCODEFORMAT_UTF16LE, String, sizeof( String ), ( const char * )UTF16LE_EN_N ) ;

	// Oo͂
	return LogFileAddUTF16LE( String ) ;
}










// Ot@CɕoAG[R[hݒ( char )
extern int LogFileAddWithErrorCode_A( int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const char *String )
{
#ifdef UNICODE
	int Result ;

	SHIFT_JIS_TO_WCHAR_T_STRING_ONE_BEGIN( String, return -1 ) ;

	Result = LogFileAdd_WCHAR_T( ErrorCode, UseStringBuffer ) ;

	SHIFT_JIS_TO_WCHAR_T_STRING_END( String ) ;

	return Result ;
#else
	int Result ;

	CHAR_TO_WCHAR_T_STRING_BEGIN( String )
	CHAR_TO_WCHAR_T_STRING_SETUP( String, return -1, DX_CHARCODEFORMAT_SHIFTJIS ) ;

	Result = LogFileAdd_WCHAR_T( ErrorCode, UseStringBuffer ) ;

	CHAR_TO_WCHAR_T_STRING_END( String ) ;

	return Result ;
#endif
}

// Ot@CɕoAG[R[hݒ( wchar_t )
extern int LogFileAddWithErrorCode_W( int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const wchar_t *String )
{
	return LogFileAdd_WCHAR_T( ErrorCode, String ) ;
}

// Ot@CɕoAG[R[hݒ( UTF16LE )
extern int LogFileAddWithErrorCode_UTF16LE( int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const char *String )
{
	int Result ;

	CHAR_TO_WCHAR_T_STRING_BEGIN( String )
	CHAR_TO_WCHAR_T_STRING_SETUP( String, return -1, DX_CHARCODEFORMAT_UTF16LE ) ;

	Result = LogFileAdd_WCHAR_T( ErrorCode, UseStringBuffer ) ;

	CHAR_TO_WCHAR_T_STRING_END( String ) ;

	return Result ;
}

// Ot@CɏtoAG[R[hݒ( char )
extern int LogFileFmtAddWithErrorCode_A( int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const char *FormatString , ... )
{
	va_list VaList ;
	char String[ 2048 ] ;
	
	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	_VSNPRINTF( String , sizeof( String ), FormatString , VaList ) ;
	
	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// sǉ
	_STRCAT_S( String, sizeof( String ), "\n" ) ;

	// Oo͂
	return LogFileAddWithErrorCode_A( ErrorCode, String ) ;
}

// Ot@CɏtoAG[R[hݒ( wchar_t )
extern int LogFileFmtAddWithErrorCode_W( int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const wchar_t *FormatString , ... )
{
	va_list VaList ;
	wchar_t String[ 2048 ] ;
	
	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	_VSWNPRINTF( String, sizeof( String ) / 2, FormatString, VaList ) ;
	
	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// sǉ
	_WCSCAT_S( String, sizeof( String ), L"\n" ) ;

	// Oo͂
	return LogFileAddWithErrorCode_W( ErrorCode, String ) ;
}

// Ot@CɏtoAG[R[hݒ( UTF16LE )
extern int LogFileFmtAddWithErrorCode_UTF16LE( int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const char *FormatString , ... )
{
	va_list VaList ;
	char String[ 2048 ] ;
	BYTE UTF16LE_EN_N[ 4 ] = { '\n', 0, 0, 0 } ;
	
	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	CL_vsnprintf( DX_CHARCODEFORMAT_UTF16LE, TRUE, CHAR_CHARCODEFORMAT, DX_CHARCODEFORMAT_UTF16LE, String, sizeof( String ) / 2, FormatString, VaList ) ;
	
	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// sǉ
	CL_strcat_s( DX_CHARCODEFORMAT_UTF16LE, String, sizeof( String ), ( const char * )UTF16LE_EN_N ) ;

	// Oo͂
	return LogFileAddWithErrorCode_UTF16LE( ErrorCode, String ) ;
}
















// LogFileAdd ̋̊֐
extern int NS_ErrorLogAdd( const TCHAR *String )
{
	NS_LogFileAdd( String ) ;
	return -1 ;
}

// Ot@C( Log.txt ) ɕo͂
extern int NS_LogFileAdd( const TCHAR *String )
{
#ifdef UNICODE
	return LogFileAdd_WCHAR_T( 0, String ) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( String, return -1 ) ;

	Result = LogFileAdd_WCHAR_T( 0, UseStringBuffer ) ;

	TCHAR_TO_WCHAR_T_STRING_END( String )

	return Result ;
#endif
}

// Ot@C( Log.txt ) ɕo͂
extern int NS_LogFileAddWithStrLen( const TCHAR *String, size_t StringLength )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( String, StringLength, return -1 )
	Result = LogFileAdd_WCHAR_T( 0, UseStringBuffer ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( String )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( String, StringLength, return -1 )
	Result = LogFileAdd_WCHAR_T( 0, UseStringBuffer ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( String )
#endif
	return Result ;
}

// LogFileFmtAdd ̋̊֐
extern int NS_ErrorLogFmtAdd( const TCHAR *FormatString , ... )
{
	TCHAR_FORMATSTRING_SETUP

	// sǉ
	_TSTRCAT_S( String, sizeof( String ), _T( "\n" ) ) ;

	// Oo͂
	NS_LogFileAdd( String ) ;
	
	return -1 ;
}

// t Ot@C( Log.txt ) ɕo͂(  printf Ɠ )
extern int NS_LogFileFmtAdd( const TCHAR *FormatString , ... )
{
	int Result ;

	TCHAR_FORMATSTRING_SETUP

	// sǉ
	_TSTRCAT_S( String, sizeof( String ), _T( "\n" ) ) ;

	// Oo͂
	Result = NS_LogFileAdd( String ) ;
	
	return Result ;
}

// t Ot@C( Log.txt ) ɕo͂(  printf Ɠ )
extern int LogFileFmt_WCHAR_T( int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const wchar_t *FormatString , ... )
{
	int Result ;

	WCHAR_T_FORMATSTRING_SETUP

	// sǉ
	_WCSCAT_S( String, sizeof( String ), L"\n" ) ;

	// Oo͂
	Result = LogFileAdd_WCHAR_T( ErrorCode, String ) ;
	
	return Result ;
}


// LogFileTabAdd ̋̊֐
extern int NS_ErrorLogTabAdd( void )
{
	return NS_LogFileTabAdd() ;
}

// Ot@C( Log.txt ) ɏo͂镶̑Oɕt^u̐₷
extern int NS_LogFileTabAdd( void )
{
	LogData.LogFileTabNum ++ ;

	return 0 ;
}

// LogFileTabSub ̋̊֐
extern int NS_ErrorLogTabSub( void )
{
	return NS_LogFileTabSub() ;
}

// Ot@C( Log.txt ) ɏo͂镶̑Oɕt^u̐炷
extern int NS_LogFileTabSub( void )
{
	if( LogData.LogFileTabNum != 0 ) LogData.LogFileTabNum -- ;

	return 0 ;
}

// ^CX^v̗Lݒ肷
extern int NS_SetUseTimeStampFlag( int UseFlag )
{
	LogData.NonUseTimeStampFlag = UseFlag != 0 ? 0 : 1 ;

	return 0 ;
}

// tOo
extern int NS_AppLogAdd( const TCHAR *String, ... )
{
	va_list VaList ;
	TCHAR StringBuf[ 2048 ] ;

	va_start( VaList, String ) ;
	_TVSNPRINTF( StringBuf, sizeof( StringBuf ) / sizeof( TCHAR ), String, VaList ) ;
	va_end( VaList ) ;

	return NS_ErrorLogAdd( StringBuf ) ;
}

// Ot@Čn
extern int LogFileTerminate( void )
{
	// ˑs
	LogFileTerminate_PF() ;

	// NeBJZNV̍폜
	CriticalSection_Delete( &LogData.CriticalSection ) ;

	// tO|
	LogData.InitializeFlag = FALSE ;

	// I
	return 0 ; 
}

// Ot@Cɓt邩ǂZbg
extern int NS_SetUseDateNameLogFile( int Flag )
{
	LogData.UseLogDateName = Flag ;

	// I
	return 0 ;
}

// Oo͂sۂ̃Zbg
extern int NS_SetOutApplicationLogValidFlag( int Flag )
{
	// tOZbg
	LogData.NotLogOutFlag = !Flag ;

	// I
	return 0 ;
}

// Ot@CۑfBNgpXݒ肷
extern int NS_SetApplicationLogSaveDirectory( const TCHAR *DirectoryPath )
{
#ifdef UNICODE
	return SetApplicationLogSaveDirectory_WCHAR_T( DirectoryPath ) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( DirectoryPath, return -1 )

	Result = SetApplicationLogSaveDirectory_WCHAR_T( UseDirectoryPathBuffer ) ;

	TCHAR_TO_WCHAR_T_STRING_END( DirectoryPath )

	return Result ;
#endif
}

// Ot@C( Log.txt ) ۑfBNgpXݒ肷
extern int NS_SetApplicationLogSaveDirectoryWithStrLen( const TCHAR *DirectoryPath, size_t DirectoryPathLength )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( DirectoryPath, DirectoryPathLength, return -1 )
	Result = SetApplicationLogSaveDirectory_WCHAR_T( UseDirectoryPathBuffer ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( DirectoryPath )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( DirectoryPath, DirectoryPathLength, return -1 )
	Result = SetApplicationLogSaveDirectory_WCHAR_T( UseDirectoryPathBuffer ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( DirectoryPath )
#endif
	return Result ;
}

// Ot@CۑfBNgpXݒ肷
extern int SetApplicationLogSaveDirectory_WCHAR_T( const wchar_t *DirectoryPath )
{
	// pX̒obt@̃TCY𒴂ꍇ̓G[
	if( ( _WCSLEN( DirectoryPath ) + 1 ) * sizeof( wchar_t ) > sizeof( LogData.LogOutDirectory ) )
	{
		return -1 ;
	}

	// pX̕ۑ
	_WCSCPY( LogData.LogOutDirectory, DirectoryPath ) ;

	// I
	return 0 ;
}

// Ot@C̖Oݒ肷( Log.txt ȊOɂꍇɎgp )
extern int NS_SetApplicationLogFileName( const TCHAR *FileName )
{
#ifdef UNICODE
	return SetApplicationLogFileName_WCHAR_T( FileName ) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = SetApplicationLogFileName_WCHAR_T( UseFileNameBuffer ) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// Ot@C̖Oݒ肷( Log.txt ȊOɂꍇɎgp )
extern int NS_SetApplicationLogFileNameWithStrLen( const TCHAR *FileName, size_t FileNameLength )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = SetApplicationLogFileName_WCHAR_T( UseFileNameBuffer ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = SetApplicationLogFileName_WCHAR_T( UseFileNameBuffer ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// Ot@C̖Oݒ肷( Log.txt ȊOɂꍇɎgp )
extern int SetApplicationLogFileName_WCHAR_T( const wchar_t *FileName )
{
	// t@Cobt@̃TCY𒴂ꍇ̓G[
	if( ( _WCSLEN( FileName ) + 1 ) * sizeof( wchar_t ) > sizeof( LogData.UserLogFileName ) )
	{
		return -1 ;
	}

	// t@C̕ۑ
	_WCSCPY( LogData.UserLogFileName, FileName ) ;

	// I
	return 0 ;
}









#ifndef DX_NON_PRINTF_DX

// Oo͋@\֐

// O@\̏
extern int InitializeLog( void )
{
	if( IsInitializeLog() == FALSE ) return -1 ;

	// ɏĂ牽Ȃ
	if( LogData.LogInitializeFlag == TRUE ) return 0 ;

	// tO𗧂Ă
	LogData.LogInitializeFlag = TRUE ;

	// OtHg̃TCYZbg
	LogData.LogFontSize = LOG_FONTSIZE ;

	// tHg̍쐬
	LogData.LogFontHandle = -1 ;
	LogData.LogFontHandleLostFlag = TRUE ;

	// O̗L薳tOZbg
	LogData.LogDrawFlag = FALSE ;

	// Õt@Co͗L薳tOZbg
	LogData.LogFileOutFlag = FALSE ;

	// O̕Zbg
	LogData.LogTabWidth = LOG_TABWIDTH ;

	// J[\̈ʒuZbg
	LogData.LogX = LogData.LogY = 0 ;

	// XgO
	_MEMSET( LogData.LogString, 0, sizeof( LogData.LogString ) ) ;

	// I
	return 0 ;
}

// Ǒns
extern int TerminateLog( void )
{
	// OĂȂȂɂȂ
	if( LogData.LogInitializeFlag == FALSE ) return 0 ;

	// tHgnh폜
	if( LogData.LogFontHandleLostFlag == FALSE && LogData.LogFontHandle > 0 )
	{
		NS_DeleteFontToHandle( LogData.LogFontHandle ) ;
	}
	LogData.LogFontHandleLostFlag = TRUE ;
	LogData.LogFontHandle = -1 ;

	// tO|
	LogData.LogInitializeFlag = FALSE ;

	// I
	return 0 ;
}

// OŎgpĂtHgXV
static int RefreshLogFont( void )
{
	if( LogData.LogInitializeFlag == FALSE )
	{
		if( InitializeLog() < 0 )
		{
			return 0 ;
		}
	}

	if( LogData.LogFontHandleLostFlag == FALSE )
	{
		return 0 ;
	}

	// tHgnh쐬
	CREATEFONTTOHANDLE_GPARAM GParam ;
	InitCreateFontToHandleGParam( &GParam ) ;
	LogData.LogFontHandle = CreateFontToHandle_UseGParam( &GParam, NULL, LogData.LogFontSize, LOG_FONTTICK, DX_FONTTYPE_EDGE, -1, -1, FALSE, -1, FALSE ) ;
	if( LogData.LogFontHandle >= 0 )
	{
		// tHgnh폜ꂽۂɗtÕ|C^Zbg
		NS_SetFontLostFlag( LogData.LogFontHandle, &LogData.LogFontHandleLostFlag  ) ;
	}
	else
	{
		LogData.LogFontHandle = DX_DEFAULT_FONT_HANDLE ;
	}

	LogData.LogFontHandleLostFlag = FALSE ;

	return 0 ;
}

// s
static int CrLog( void )
{
	int ScWidth, ScHeight, StrHeight ;
	int FontSize = -1 ;

	if( LogData.LogInitializeFlag == FALSE )
	{
		if( InitializeLog() < 0 )
		{
			return 0 ;
		}
	}

	// tHg폜Ăꍇ͍č쐬
	RefreshLogFont() ;

	// ʂ̃TCY擾
	NS_GetDrawScreenSize( &ScWidth , &ScHeight ) ;
	
	// ʓɎ܂sZo
	if( LogData.LogUserFontHandle > 0 )
	{
		FontSize = NS_GetFontSizeToHandle( LogData.LogUserFontHandle ) ;
	}
	if( FontSize < 0 )
	{
		LogData.LogUserFontHandle = 0 ;
		FontSize = LogData.LogFontSize ;
	}
	StrHeight = ScHeight / FontSize ;
	if( StrHeight > LOG_MAXHEIGHT ) StrHeight = LOG_MAXHEIGHT ;

	// sʂOĂ܂ȂׁAO邩ǂŏ𕪊
	if( StrHeight <= LogData.LogY + 1 )
	{
		// Oꍇ͈sf[^Sďグ

		// Ps炷
		_MEMMOVE( LogData.LogString[0], LogData.LogString[1], sizeof( wchar_t ) * LOG_MAXLENGTH * LogData.LogY ) ;
	}
	else
	{
		// xWCNg
		LogData.LogY ++ ;
	}

	// Vs̕
	_MEMSET( LogData.LogString[ LogData.LogY ], 0, sizeof( wchar_t ) * LOG_MAXLENGTH ) ;

	// `敝
	LogData.LogDrawWidth = 0 ;

	// wW
	LogData.LogX = 0 ;

	// I
	return 0 ;
}

// ꕶOɒǉAKvȂs
static int AddCharLog( const wchar_t *C )
{
	int ScWidth, ScHeight ;
	int Width = 0, Length, i ;

	if( LogData.LogInitializeFlag == FALSE )
	{
		if( InitializeLog() < 0 )
		{
			return 0 ;
		}
	}

	// tHg폜Ăꍇ͍č쐬
	RefreshLogFont() ;

	// ʂ̃TCY擾
	NS_GetDrawScreenSize( &ScWidth , &ScHeight ) ;

	// V̕`敝擾
	if( CHECK_WCHAR_T_DOUBLE( *C ) == TRUE )
	{
		Length = 2 ;
	}
	else
	{
		Length = 1 ;
	}

	// 񂪃obt@I[o[ȂׂAoꍇ͉s
	if( LogData.LogX + Length >= LOG_MAXLENGTH )
	{
		CrLog() ;
	}
	else
	{
		// ʊOɏoȂׂAoꍇ͉s
		Width = GetDrawStringWidthToHandle_WCHAR_T( C, 0, Length, LogData.LogFontHandle, FALSE ) ;
		if( Width + LogData.LogDrawWidth >= ScWidth ) 
		{
			CrLog() ;
		}
	}

	// `敝Z
	LogData.LogDrawWidth += Width ;

	// ǉ
	for( i = 0 ; i < Length ; i ++ )
	{
		LogData.LogString[ LogData.LogY ][ LogData.LogX + i ] = C[ i ]  ;
	}
	LogData.LogString[ LogData.LogY ][ LogData.LogX + i ] = L'\0' ;

	// J[\ʒuCNg
	LogData.LogX += Length  ;

	// I
	return Length ;
}


// Oo
static int AddLog( const wchar_t *String )
{
	int StrLen ;

	if( LogData.LogInitializeFlag == FALSE )
	{
		if( InitializeLog() < 0 )
		{
			return 0 ;
		}
	}

	// tHg폜Ăꍇ͍č쐬
	RefreshLogFont() ;

	// ꕶÂǉĂ
	{
		int i ;
		const wchar_t *C ;

		// r؂܂ŌJԂ
		StrLen = ( int )_WCSLEN( String ) ;
		for( i = 0 ; i < StrLen ; i ++ )
		{
			C = &String[ i ] ;

			// ̃̕^Cvɂď𕪊
			switch( *C )
			{
			case L'\n' :
				// sR[h̏ꍇ͉ss
				CrLog() ;
				break ;

			case L'\t' :
				{
					int j ;

					// ^ȕꍇ̓^u̕Xy[Xǉ
					for( j = 0 ; j < LogData.LogTabWidth ; j ++ )
						AddCharLog( L" " )  ;
				}
				break ;

			case L'\a' : case L'\b' : 
			case L'\f' : case L'\r' : case L'\v' :
				break ;

			default :
				// ȊȌꍇ͕ʂɒǉ
				if( AddCharLog( C ) == 2 ) i ++ ;
				break ;
			}
		}
	}

	// I
	return 0 ;
}

// Ȍ
static int ClrLog( void )
{
	if( LogData.LogInitializeFlag == FALSE )
	{
		if( InitializeLog() < 0 )
		{
			return 0 ;
		}
	}

	// tHg폜Ăꍇ͍č쐬
	RefreshLogFont() ;

	// O
	_MEMSET( LogData.LogString, 0, sizeof( LogData.LogString ) ) ;

	// J[\ʒu
	LogData.LogX = LogData.LogY = 0 ;
	LogData.LogDrawWidth = 0 ;

	// I
	return 0 ;
}

// Oo̓tOZbg
extern int NS_SetLogDrawOutFlag( int DrawFlag )
{
	// O`o̓tOZbg
	LogData.LogDrawFlag = DrawFlag ;

	// I
	return 0 ;
}

// Oo͂邩tO̎擾
extern int NS_GetLogDrawFlag( void )
{
	return LogData.LogDrawFlag ;
}

// printfDx ŉʂɏo͂郍OtHg̃TCYύX
extern int NS_SetLogFontSize( int Size )
{
	if( Size < 0 ) Size = LOG_FONTSIZE;

	LogData.LogFontSize = Size;

	if( LogData.LogFontHandle >= 0 )
	{
		DeleteFontToHandle( LogData.LogFontHandle );
		LogData.LogFontHandle = -1;
		LogData.LogFontHandleLostFlag = TRUE;
	}

	RefreshLogFont();

	// I
	return 0;
}

// printfDx ̌ʂʂɏo͂ۂɎgptHg̃nhύX
extern int NS_SetLogFontHandle( int FontHandle )
{
	LogData.LogUserFontHandle = FontHandle ;

	// I
	return 0 ;
}

// printfDx ̌ʂʂɏo͂ۂ̕`悷̈ݒ肷
extern int NS_SetLogDrawArea( int x1, int y1, int x2, int y2 )
{
	LogData.LogDrawArea.left   = x1 ;
	LogData.LogDrawArea.top    = y1 ;
	LogData.LogDrawArea.right  = x2 ;
	LogData.LogDrawArea.bottom = y2 ;

	// I
	return 0 ;
}

// O`悷
extern int DrawLog( void )
{
	int StrHeight , i ;
	int DrawX, DrawY ;
	int DrawW, DrawH ;
	int FontSize = -1 ;
	int FontHandle ;
	int Color ;
	int EdgeColor ;

	if( LogData.LogInitializeFlag == FALSE )
	{
		if( InitializeLog() < 0 )
		{
			return 0 ;
		}
	}

	// Lȕ`͈͂ݒ肳Ăgp
	DrawX = LogData.LogDrawArea.left ;
	DrawY = LogData.LogDrawArea.top ;
	DrawW = LogData.LogDrawArea.right  - LogData.LogDrawArea.left ;
	DrawH = LogData.LogDrawArea.bottom - LogData.LogDrawArea.top ;
	if( DrawW == 0 || DrawH == 0 )
	{
		// Wł͕`͉ʍ
		DrawX = 0 ;
		DrawY = 0 ;

		// ʂ̃TCY擾
		NS_GetDrawScreenSize( &DrawW , &DrawH ) ;
	}

	// tHg폜Ăꍇ͍č쐬
	RefreshLogFont() ;
	
	// ʂɃO`悷
	if( LogData.LogUserFontHandle > 0 )
	{
		FontSize = NS_GetFontSizeToHandle( LogData.LogUserFontHandle ) ;
	}
	if( FontSize < 0 )
	{
		LogData.LogUserFontHandle = 0 ;
		FontSize = LogData.LogFontSize ;
		FontHandle = LogData.LogFontHandle ;
	}
	else
	{
		FontHandle = LogData.LogUserFontHandle ;
	}
	StrHeight = DrawH / FontSize  ;
	if( StrHeight >= LOG_MAXHEIGHT ) StrHeight = LOG_MAXHEIGHT ;

	Color = NS_GetColor( 255, 255, 255 ) ;
	EdgeColor = NS_GetColor( 0, 0, 0 ) ;
	for( i = 0 ; i < StrHeight ; i ++ )
	{
		DrawStringToHandle_WCHAR_T( DrawX , DrawY + i * FontSize , LogData.LogString[ i ] , _WCSLEN( LogData.LogString[ i ] ) , Color, FontHandle , EdgeColor, FALSE ) ;
	}

	// I
	return 0 ;
}






// ȈՉʏo͊֐
extern int printfDxBase( const TCHAR *String )
{
	int Result ;

#ifdef UNICODE
	Result = printfDxBase_WCHAR_T( String ) ;
#else
	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( String, return -1 )

	Result = printfDxBase_WCHAR_T( UseStringBuffer ) ;

	TCHAR_TO_WCHAR_T_STRING_END( String )
#endif

	// I
	return Result ;
}

// ȈՉʏo͊֐
extern int NS_printfDx( const TCHAR *FormatString , ... )
{
	int Result ;

	TCHAR_FORMATSTRING_SETUP

#ifdef UNICODE
	Result = printfDxBase_WCHAR_T( String ) ;
#else
	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( String, return -1 )

	Result = printfDxBase_WCHAR_T( UseStringBuffer ) ;

	TCHAR_TO_WCHAR_T_STRING_END( String )
#endif

	// I
	return Result ;
}

// ȈՉʏo͊֐
extern int printfDx_WCHAR_T( const wchar_t *FormatString , ... )
{
	int Result ;

	WCHAR_T_FORMATSTRING_SETUP

	// Oo̓tO𗧂Ă
	LogData.LogDrawFlag = TRUE ;

	// Oo͊֐Ă
	Result = AddLog( String ) ;

	// I
	return Result ;
}

// printfDx_WCHAR_T ̏ł͂ȂƂo[W
extern int printfDxBase_WCHAR_T( const wchar_t *String )
{
	int Result ;

	// Oo̓tO𗧂Ă
	LogData.LogDrawFlag = TRUE ;

	// Oo͊֐Ă
	Result = AddLog( String ) ;

	// I
	return Result ;
}

// puts Ɠŉʂɕ\邽߂̊֐
extern int NS_putsDx( const TCHAR *String, int NewLine )
{
#ifdef UNICODE
	return putsDx_WCHAR_T( String, NewLine ) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( String, return -1 )

	Result = putsDx_WCHAR_T( UseStringBuffer, NewLine ) ;

	TCHAR_TO_WCHAR_T_STRING_END( String )

	return Result ;
#endif
}

// puts Ɠŉʂɕ\邽߂̊֐
extern int NS_putsDxWithStrLen( const TCHAR *String, size_t StringLength, int NewLine )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( String, StringLength, return -1 )
	Result = putsDx_WCHAR_T( UseStringBuffer, NewLine ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( String )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( String, StringLength, return -1 )
	Result = putsDx_WCHAR_T( UseStringBuffer, NewLine ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( String )
#endif
	return Result ;
}

// puts Ɠŉʂɕ\邽߂̊֐
extern int putsDx_WCHAR_T( const wchar_t *String , int NewLine )
{
	int Result ;

	// Oo̓tO𗧂Ă
	LogData.LogDrawFlag = TRUE ;

	// Oo͊֐Ă
	Result = AddLog( String ) ;
	if( Result < 0 )
	{
		return -1 ;
	}

	// sǉ
	if( NewLine )
	{
		Result = AddLog( L"\n" ) ;
	}

	// I
	return Result ;
}

// ȈՉʏo͂NA
extern int NS_clsDx( void )
{
	// O
	ClrLog() ;

	// Oo̓tO|
	LogData.LogDrawFlag = FALSE ;

	// I
	return 0 ;
}

#endif // DX_NON_PRINTF_DX


#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_LOG

